#include <cstddef>

#include <map>
#include <string>
#include <vector>

class KmerCounter
{
public:
  KmerCounter(const std::string& cs);
  ~KmerCounter();
  void count(const std::string& s, std::size_t k, std::vector<unsigned int>& cnt) const;
  std::size_t char_type_size() const;
  std::size_t kmer_type_size(std::size_t k) const;

private:
  std::string cs_;
  std::map<char, unsigned int> m_;
  std::size_t char_type_size_;
};
