/*
 * query.h
 *
 *  Created on: 2011/02/21
 *      Author: shu
 */

#ifndef QUERY_H_
#define QUERY_H_

#include <string>
#include "aligner_parameters.h"
#include "encoder.h"
#include "statistics.h"
#include "sequence_index.h"
#include "sequence.h"

using namespace std;

class Query {
public:

  Query(const AlignerParameters &parameters);
  virtual ~Query();

  virtual string GetName() {
    return name_;
  }

  virtual Code *GetSequence() {
    return &sequence_[0];
  }

  virtual uint32_t GetSequenceLength() {
    return sequence_.size();
  }

  virtual uint32_t GetRealSequenceLength() {
    return sequence_.size();
  }

  virtual uint32_t GetRealStart(uint32_t pos) {
    return pos;
  }

  virtual uint32_t GetRealEnd(uint32_t pos) {
    return pos;
  }

  virtual SequenceIndex *GetIndex() {
    return index_;
  }

  virtual KarlinParameters GetUngappedKarlinParameters() {
    return ungapped_karlin_parameters_;
  }

  virtual int GetUngappedExtendNominalCutoff() {
    return ungapped_extend_nominal_cutoff_;
  }

  virtual int GetGappedExtendNominalCutoff() {
    return gapped_extend_nominal_cutoff_;
  }

  virtual int GetGappedExtendNominalTrigger() {
    return gapped_extend_nominal_trigger_;
  }

protected:
  string name_;
  vector<Code> sequence_;
  SequenceIndex *index_;
  KarlinParameters ungapped_karlin_parameters_;
  int ungapped_extend_nominal_cutoff_;
  int gapped_extend_nominal_cutoff_;
  int gapped_extend_nominal_trigger_;


};

#endif /* QUERY_H_ */
