/*
 * fasta_sequence_reader.h
 *
 *  Created on: 2009/06/19
 *      Author: shu
 */

#ifndef FASTA_SEQUENCE_READER_H_
#define FASTA_SEQUENCE_READER_H_

#include <fstream>
#include <ios>
#include <assert.h>
#include <string>
#include "sequence.h"
#include "sequence_reader.h"

class FastaSequenceReader: public SequenceReader {
public:
  // constructor
  FastaSequenceReader(const char* file_name) {
    in_.open(file_name);
    if (!in_) {
      throw std::ios_base::failure("can't open file:" + std::string(file_name));
    }
    assert(in_&&"can't open file:");
    last_line_ = "";
  }

  // destructor
  ~FastaSequenceReader() {
    in_.close();
  }

  SequencePtr Read();
private:

  std::ifstream in_; // input file stream
  std::string last_line_; // last input line
};

#endif /* FASTA_SEQUENCE_READER_H_ */
